/*
# Copyright (c) 2003-2004 by the University of Southern California.
# All rights reserved.
#
# Permission to use, copy, modify, and distribute this software and its
# documentation in source and binary forms for non-commercial purposes and
# without fee is hereby granted, provided that the above copyright notice
# appear in all copies and that both the copyright notice and this permission
# notice appear in supporting documentation, and that any documentation,
# advertising materials, and other materials related to such distribution and
# use acknowledge that the software was developed by the University of
# Southern California, Information Sciences Institute.  The name of the
# University may not be used to endorse or promote products derived from this
# software without specific prior written permission.
#
# THE UNIVERSITY OF SOUTHERN CALIFORNIA MAKES NO REPRESENTATIONS ABOUT THE
# SUITABILITY OF THIS SOFTWARE FOR ANY PURPOSE.  THIS SOFTWARE IS PROVIDED "AS
# IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT
# LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
# PARTICULAR PURPOSE.
#
# Other copyrights might apply to parts of this software and are so noted when
# applicable.
# ----------------------------------------------------------------------------
#
# Primary author: Purushotham Kamath
#                 Sept  2004
#This material is based upon work supported by the Defense Advanced Research 
#Projects Agency under contract no. N66001-02-1-8939 issued by the Space and 
#Naval Warfare Systems Center (SPAWAR).  Any opinions, findings, and conclusions 
#or recommendations expressed in this material are those of the author(s) and 
#do not necessarily reflect the views of the Defense Advanced Research Projects
#Agency, SPAWAR, or the U.S. Government.
*/


#ifndef STATEEST_H
#define STATEEST_H



class StateEstimator :public EventHandler
{
private:
	int A;
	int N;
public:


//State estimation parameters:
	double ne;
	int alg;
	int topology;


//These are used if the hardware is not capable of collect N chip samples in a bit interval.
	double sampling;
	double samplingfreq;
	
	StateEstimator(int, int);
	virtual ~StateEstimator();
	virtual void process(Packet *);		
	virtual void handleevent(Packet *);		
	


	//Functions to calculate the state at a point (the time is implicit i.e. the current time)
	int *calcstate(double ex);
	int *calcstateobservation(double ex);

	int dumpstate(int *);

	int calcchipoffset(double, double);
	void dumpstats();

	void hardlimit(int *, int);
};

enum {STATEEST_PERFECT=0, STATEEST_ONDEMAND, STATEEST_CONTINUOUS, STATEEST_REDUCED};
enum {TOPOLOGY_STAR=0, TOPOLOGY_BUS};
enum {NO=0, YES};
enum {EST=0, MERGE};
#endif

